#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("util");
var chalk_1 = __importDefault(require("chalk"));
var child_process_1 = __importDefault(require("child_process"));
var console_1 = require("console");
var enquirer_1 = require("enquirer");
var utils_1 = require("./utils");
var steps_1 = require("./steps");
var exec = (0, util_1.promisify)(child_process_1.default.exec);
function main() {
    return __awaiter(this, void 0, void 0, function () {
        var stdout, hasFilesStaged, stdout_1, answers, result, _a, stdout_2, err_1;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    (0, console_1.clear)();
                    return [4 /*yield*/, exec("git diff --name-only --cached", {
                            cwd: process.cwd(),
                        })];
                case 1:
                    stdout = (_b.sent()).stdout;
                    hasFilesStaged = stdout.trim() !== "";
                    if (!!hasFilesStaged) return [3 /*break*/, 3];
                    console.log(chalk_1.default.red("No files staged for commit. Aborting commit."));
                    return [4 /*yield*/, exec("git status", {
                            cwd: process.cwd(),
                        })];
                case 2:
                    stdout_1 = (_b.sent()).stdout;
                    console.error("\n".concat(stdout_1));
                    return [2 /*return*/];
                case 3:
                    _b.trys.push([3, 11, , 12]);
                    return [4 /*yield*/, (0, enquirer_1.prompt)((0, steps_1.getCommitSteps)())];
                case 4:
                    answers = _b.sent();
                    if (!(answers && answers.confirmCommit)) return [3 /*break*/, 9];
                    result = (0, utils_1.buildCommitMessage)(answers);
                    _b.label = 5;
                case 5:
                    _b.trys.push([5, 7, , 8]);
                    return [4 /*yield*/, exec("git commit -m \"".concat(result, "\""), {
                            cwd: process.cwd(),
                        })];
                case 6:
                    _b.sent();
                    return [3 /*break*/, 8];
                case 7:
                    _a = _b.sent();
                    stdout_2 = _a.stdout;
                    console.error(chalk_1.default.red(stdout_2));
                    return [3 /*break*/, 8];
                case 8: return [3 /*break*/, 10];
                case 9:
                    console.log(chalk_1.default.red("\nCommit has been canceled."));
                    _b.label = 10;
                case 10: return [3 /*break*/, 12];
                case 11:
                    err_1 = _b.sent();
                    console.error(err_1);
                    return [3 /*break*/, 12];
                case 12: return [2 /*return*/];
            }
        });
    });
}
main();
