"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCommitTypesMapped = exports.buildCommitMessage = void 0;
var config_json_1 = __importDefault(require("./config.json"));
var MAX_LINE_LENGTH = config_json_1.default.git.max_line_length;
var buildCommitMessage = function (answers) {
    var type = answers.type, scope = answers.scope, description = answers.description, body = answers.body, footer = answers.footer;
    var commitMsg = "".concat(type).concat(scope, ": ").concat(description);
    var result = commitMsg.slice(0, MAX_LINE_LENGTH);
    result += "".concat(body).concat(footer);
    return result;
};
exports.buildCommitMessage = buildCommitMessage;
var getCommitTypesMapped = function () {
    var types = config_json_1.default.types;
    return Object.keys(types).map(function (value) {
        return {
            name: value,
            message: types[value].description,
        };
    });
};
exports.getCommitTypesMapped = getCommitTypesMapped;
